diff -r ee55d0546576 src/smallmap_gui.cpp
--- a/src/smallmap_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/smallmap_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -20,6 +20,7 @@
 #include "vehicle_base.h"
 #include "sound_func.h"
 #include "window_func.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -97,6 +98,20 @@
 static const LegendAndColour _legend_routes[] = {
 	MK(0xD7, STR_SMALLMAP_LEGENDA_ROADS),
 	MK(0x0A, STR_SMALLMAP_LEGENDA_RAILROADS),
+	MK(0xB5, STR_SMALLMAP_LEGENDA_BUILDINGS_INDUSTRIES),
+	MS(0x56, STR_SMALLMAP_LEGENDA_RAILROAD_STATION),
+
+	MK(0xC2, STR_SMALLMAP_LEGENDA_TRUCK_LOADING_BAY),
+	MK(0xBF, STR_SMALLMAP_LEGENDA_BUS_STATION),
+	MK(0xB8, STR_SMALLMAP_LEGENDA_AIRPORT_HELIPORT),
+	MK(0x98, STR_SMALLMAP_LEGENDA_DOCK),
+	MKEND()
+};
+
+static const LegendAndColour _legend_routes_sharing[] = {
+	MK(0xD7, STR_SMALLMAP_LEGENDA_ROADS),
+	MK(0x0E, STR_SMALLMAP_LEGENDA_RAILROADS_ACCESSIBLE),
+	MK(0x11, STR_SMALLMAP_LEGENDA_RAILROADS_INACCESSIBLE),
 	MK(0xB5, STR_SMALLMAP_LEGENDA_BUILDINGS_INDUSTRIES),
 	MS(0x56, STR_SMALLMAP_LEGENDA_RAILROAD_STATION),
 
@@ -395,6 +410,14 @@
 			case STATION_BUS:     bits = MKCOLOUR(0xBFBFBFBF); break;
 			case STATION_DOCK:    bits = MKCOLOUR(0x98989898); break;
 			default:              bits = MKCOLOUR(0xFFFFFFFF); break;
+		}
+	} else if (t == MP_RAILWAY && ShowSharingOnMap()) {
+		if (IsRailwayTileUsageAllowed(tile, _local_company)) {
+			/* Make rails color 0x0E (light grey), ground colour 0x54 (green) */
+			bits = MKCOLOUR(0x540E0E54);
+		} else {
+			/* Make rails color 0x11 (dark grey), ground colour 0x54 (green) */
+			bits = MKCOLOUR(0x54111154);
 		}
 	} else {
 		/* ground colour */
@@ -840,7 +863,8 @@
 		int x = 4;
 		int y = y_org;
 
-		for (const LegendAndColour *tbl = _legend_table[this->map_type]; !tbl->end; ++tbl) {
+		const LegendAndColour *tbl = (this->map_type == SMT_ROUTES && ShowSharingOnMap()) ? _legend_routes_sharing : _legend_table[this->map_type];
+		while (!tbl->end) {
 			if (tbl->col_break || y >= legend->bottom) {
 				/* Column break needed, continue at top, COLUMN_WIDTH pixels
 				 * (one "row") to the right. */
@@ -870,6 +894,7 @@
 			GfxFillRect(x + 1, y + 2, x + 7, y + 4, tbl->colour); // legend colour
 
 			y += 6;
+			tbl++;
 		}
 
 		const Widget *wi = &this->widget[SM_WIDGET_MAP];
diff -r ee55d0546576 src/table/settings.h
--- a/src/table/settings.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/table/settings.h	Sat Apr 25 19:58:24 2009 +0200
@@ -27,6 +27,9 @@
 static int32 CheckNoiseToleranceLevel(const char *value);
 static bool CheckFreeformEdges(int32 p1);
 static bool ChangeDynamicEngines(int32 p1);
+static bool UpdateAllSharingSettings(int32 p1);
+static bool UpdateSharingEnabled(int32 p1);
+static bool UpdateSharingDelay(int32 p1);
 
 #ifdef ENABLE_NETWORK
 static bool UpdateClientName(int32 p1);
@@ -434,6 +437,18 @@
 	    SDT_BOOL(GameSettings, ai.ai_disable_veh_ship,                                              0, 0, false,                    STR_CONFIG_SETTING_AI_BUILDS_SHIPS,        NULL),
 	 SDT_CONDVAR(GameSettings, ai.ai_max_opcode_till_suspend,       SLE_UINT32,107, SL_MAX_VERSION, 0, NG, 10000, 5000,250000,2500, STR_CONFIG_SETTING_AI_MAX_OPCODES,         NULL),
 
+	SDT_CONDBOOL(GameSettings, sharing.enable_sharing,                       SL_IS, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_SETTING_SHARING_ENABLE,         UpdateSharingEnabled),
+	SDT_CONDBOOL(GameSettings, sharing.individual_allowed,                   SL_IS, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_SETTING_SHARING_INDIVIDUAL,     UpdateAllSharingSettings),
+ 	 SDT_CONDVAR(GameSettings, sharing.new_individual_delay,       SLE_UINT8,SL_IS, SL_MAX_VERSION, 0, 0, 12, 0,            120, 1, STR_CONFIG_SETTING_SHARING_INDIVIDUAL_TIME,UpdateSharingDelay),
+	 SDT_CONDVAR(GameSettings, sharing.rail_sharing,               SLE_UINT8,SL_IS, SL_MAX_VERSION, 0,MS,  0, 0,              4, 0, STR_CONFIG_SETTING_SHARING_RAIL,           UpdateAllSharingSettings),
+	SDT_CONDBOOL(GameSettings, sharing.road_sharing,                         SL_IS, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_SETTING_SHARING_ROAD,           UpdateAllSharingSettings),
+	SDT_CONDBOOL(GameSettings, sharing.water_sharing,                        SL_IS, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_SETTING_SHARING_WATER,          UpdateAllSharingSettings),
+	SDT_CONDBOOL(GameSettings, sharing.air_sharing,                          SL_IS, SL_MAX_VERSION, 0, 0, false,                    STR_CONFIG_SETTING_SHARING_AIR,            UpdateAllSharingSettings),
+	 SDT_CONDVAR(GameSettings, sharing.rail_fee,                  SLE_UINT16,SL_IS, SL_MAX_VERSION, 0,CR,100, 0,MAX_SHARING_FEE,10, STR_CONFIG_SETTING_SHARING_RAIL_FEE,       UpdateAllSharingSettings),
+	 SDT_CONDVAR(GameSettings, sharing.road_fee,                  SLE_UINT16,SL_IS, SL_MAX_VERSION, 0,CR,100, 0,MAX_SHARING_FEE,10, STR_CONFIG_SETTING_SHARING_ROAD_FEE,       UpdateAllSharingSettings),
+	 SDT_CONDVAR(GameSettings, sharing.water_fee,                 SLE_UINT16,SL_IS, SL_MAX_VERSION, 0,CR,100, 0,MAX_SHARING_FEE,10, STR_CONFIG_SETTING_SHARING_WATER_FEE,      UpdateAllSharingSettings),
+	 SDT_CONDVAR(GameSettings, sharing.air_fee,                   SLE_UINT16,SL_IS, SL_MAX_VERSION, 0,CR,100, 0,MAX_SHARING_FEE,10, STR_CONFIG_SETTING_SHARING_AIR_FEE,        UpdateAllSharingSettings),
+
 	     SDT_VAR(GameSettings, vehicle.extend_vehicle_life,          SLE_UINT8,                     0, 0,     0,     0,     100, 0, STR_NULL,                                  NULL),
 	     SDT_VAR(GameSettings, economy.dist_local_authority,         SLE_UINT8,                     0, 0,    20,     5,      60, 0, STR_NULL,                                  NULL),
 	     SDT_VAR(GameSettings, pf.wait_oneway_signal,                SLE_UINT8,                     0, 0,    15,     2,     255, 0, STR_NULL,                                  NULL),
diff -r ee55d0546576 src/train.h
--- a/src/train.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/train.h	Sat Apr 25 19:58:24 2009 +0200
@@ -298,6 +298,7 @@
 void CheckTrainsLengths();
 
 void FreeTrainTrackReservation(const Vehicle *v, TileIndex origin = INVALID_TILE, Trackdir orig_td = INVALID_TRACKDIR);
+void ClearPathReservation(const Vehicle *v, TileIndex tile, Trackdir track_dir);
 bool TryPathReserve(Vehicle *v, bool mark_as_stuck = false, bool first_tile_okay = false);
 
 int GetTrainStopLocation(StationID station_id, TileIndex tile, const Vehicle *v, int *station_ahead, int *station_length);
diff -r ee55d0546576 src/train_cmd.cpp
--- a/src/train_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/train_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -33,6 +33,7 @@
 #include "effectvehicle_func.h"
 #include "gamelog.h"
 #include "network/network.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/train_cmd.h"
@@ -793,7 +794,7 @@
 	/* Check if the train is actually being built in a depot belonging
 	 * to the company. Doesn't matter if only the cost is queried */
 	if (!IsRailDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!AreDepotOperationsAllowed(tile, _current_company, VEH_TRAIN)) return CMD_ERROR;
 
 	const RailVehicleInfo *rvi = RailVehInfo(p1);
 	if (rvi->railveh_type == RAILVEH_WAGON) return CmdBuildRailWagon(p1, tile, flags);
@@ -1966,7 +1967,7 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v->type != VEH_TRAIN || !IsVehicleControlAllowed(v)) return CMD_ERROR;
 
 	if (p2 != 0) {
 		/* turn a single unit around */
@@ -2027,7 +2028,7 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v->type != VEH_TRAIN || !IsVehicleControlAllowed(v)) return CMD_ERROR;
 
 	if (flags & DC_EXEC) v->u.rail.force_proceed = 0x50;
 
@@ -2147,8 +2148,8 @@
 static bool NtpCallbFindDepot(TileIndex tile, TrainFindDepotData *tfdd, int track, uint length)
 {
 	if (IsTileType(tile, MP_RAILWAY) &&
-			IsTileOwner(tile, tfdd->owner) &&
-			IsRailDepot(tile)) {
+			IsRailDepot(tile) &&
+			IsDepotUsageAllowed(tile, tfdd->owner, VEH_TRAIN)) {
 		/* approximate number of tiles by dividing by DIAG_FACTOR */
 		tfdd->best_length = length / DIAG_FACTOR;
 		tfdd->tile = tile;
@@ -2473,7 +2474,7 @@
 }
 
 /** Clear the reservation of a tile that was just left by a wagon on track_dir. */
-static void ClearPathReservation(const Vehicle *v, TileIndex tile, Trackdir track_dir)
+void ClearPathReservation(const Vehicle *v, TileIndex tile, Trackdir track_dir)
 {
 	DiagDirection dir = TrackdirToExitdir(track_dir);
 
@@ -3418,7 +3419,7 @@
 static inline bool CheckCompatibleRail(const Vehicle *v, TileIndex tile)
 {
 	return
-		IsTileOwner(tile, v->owner) && (
+		IsRailwayTileUsageAllowed(tile, v->owner) && (
 			!IsFrontEngine(v) ||
 			HasBit(v->u.rail.compatible_railtypes, GetRailType(tile))
 		);
@@ -4510,6 +4511,9 @@
 			/* running costs */
 			CommandCost cost(EXPENSES_TRAIN_RUN, this->GetRunningCost() * this->running_ticks / (DAYS_IN_YEAR  * DAY_TICKS));
 
+			/* sharing fee */
+			PayDailyTrackSharingFee(this);
+
 			this->profit_this_year -= cost.GetCost();
 			this->running_ticks = 0;
 
diff -r ee55d0546576 src/vehicle.cpp
--- a/src/vehicle.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/vehicle.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -37,6 +37,7 @@
 #include "depot_func.h"
 #include "settings_type.h"
 #include "network/network.h"
+#include "infrastructure_func.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -1551,6 +1552,9 @@
 		case OT_LOADING: {
 			uint wait_time = max(this->current_order.wait_time - this->lateness_counter, 0);
 
+			/* Pay the loading fee when using someone else's station */
+			if (!(mode || this->type == VEH_TRAIN)) PayStationSharingFee(this, GetStation(this->last_station_visited));
+
 			/* Not the first call for this tick, or still loading */
 			if (mode || !HasBit(this->vehicle_flags, VF_LOADING_FINISHED) ||
 					(_settings_game.order.timetabling && this->current_order_time < wait_time)) return;
diff -r ee55d0546576 src/vehicle_cmd.cpp
--- a/src/vehicle_cmd.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/vehicle_cmd.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -18,6 +18,7 @@
 #include "string_func.h"
 #include "depot_map.h"
 #include "vehiclelist.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 
@@ -65,7 +66,7 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (!CheckOwnership(v->owner)) return CMD_ERROR;
+	if (!IsVehicleControlAllowed(v)) return CMD_ERROR;
 	if (!v->IsPrimaryVehicle()) return CMD_ERROR;
 
 	switch (v->type) {
@@ -223,7 +224,7 @@
 	VehicleType vehicle_type = (VehicleType)GB(p1, 0, 8);
 	bool all_or_nothing = HasBit(p2, 0);
 
-	if (!IsDepotTile(tile) || !IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!IsDepotTile(tile) || !AreDepotOperationsAllowed(tile, _current_company, vehicle_type)) return CMD_ERROR;
 
 	/* Get the list of vehicles in the depot */
 	BuildDepotVehicleList(vehicle_type, tile, &list, &list, true);
diff -r ee55d0546576 src/vehicle_gui.cpp
--- a/src/vehicle_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/vehicle_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -30,6 +30,7 @@
 #include "vehiclelist.h"
 #include "settings_type.h"
 #include "articulated_vehicles.h"
+#include "infrastructure_func.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -1893,6 +1894,7 @@
 		const Vehicle *v = GetVehicle(this->window_number);
 		StringID str;
 		bool is_localcompany = v->owner == _local_company;
+		bool can_control = IsVehicleControlAllowed(v);
 		bool refitable_and_stopped_in_depot = IsVehicleRefitable(v);
 
 		this->SetWidgetDisabledState(VVW_WIDGET_GOTO_DEPOT, !is_localcompany);
@@ -1901,8 +1903,8 @@
 		this->SetWidgetDisabledState(VVW_WIDGET_CLONE_VEH, !is_localcompany);
 
 		if (v->type == VEH_TRAIN) {
-			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_localcompany);
-			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_localcompany);
+			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !can_control);
+			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !can_control);
 		}
 
 		/* draw widgets & caption */
diff -r ee55d0546576 src/window_type.h
--- a/src/window_type.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/window_type.h	Sat Apr 25 19:58:24 2009 +0200
@@ -99,6 +99,7 @@
 	WC_AI_DEBUG,
 	WC_AI_LIST,
 	WC_AI_SETTINGS,
+	WC_SHARING_OPTIONS,
 
 	WC_INVALID = 0xFFFF
 };
diff -r ee55d0546576 src/yapf/follow_track.hpp
--- a/src/yapf/follow_track.hpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/yapf/follow_track.hpp	Sat Apr 25 19:58:24 2009 +0200
@@ -7,6 +7,7 @@
 
 #include "yapf.hpp"
 #include "../depot_map.h"
+#include "../infrastructure_func.h"
 
 /** Track follower helper template class (can serve pathfinders and vehicle
  *  controllers). See 6 different typedefs below for 3 different transport
@@ -53,12 +54,12 @@
 	{
 		assert(!IsRailTT() || (v != NULL && v->type == VEH_TRAIN));
 		m_veh = v;
-		Init(v != NULL ? v->owner : INVALID_OWNER, railtype_override == INVALID_RAILTYPES ? v->u.rail.compatible_railtypes : railtype_override, pPerf);
+		Init(v != NULL ? v->owner : INVALID_OWNER, (railtype_override == INVALID_RAILTYPES && v != NULL) ? v->u.rail.compatible_railtypes : railtype_override, pPerf);
 	}
 
 	FORCEINLINE void Init(Owner o, RailTypes railtype_override, CPerformanceTimer *pPerf)
 	{
-		assert((!IsRoadTT() || m_veh != NULL) && (!IsRailTT() || railtype_override != INVALID_RAILTYPES));
+		assert(!IsRoadTT() || m_veh != NULL);
 		m_veh_owner = o;
 		m_pPerf = pPerf;
 		/* don't worry, all is inlined so compiler should remove unnecessary initializations */
@@ -263,11 +264,17 @@
 	/** return true if we can enter m_new_tile from m_exitdir */
 	FORCEINLINE bool CanEnterNewTile()
 	{
+		bool ignore_owner = (m_veh_owner == INVALID_OWNER);
 		if (IsRoadTT() && IsStandardRoadStopTile(m_new_tile)) {
 			/* road stop can be entered from one direction only unless it's a drive-through stop */
 			DiagDirection exitdir = GetRoadStopDir(m_new_tile);
 			if (ReverseDiagDir(exitdir) != m_exitdir) {
 				m_err = EC_NO_WAY;
+				return false;
+			}
+			/* road stops shouldn't be entered unless allowed to */
+			if (!(ignore_owner || IsStationUsageAllowed(m_new_tile, m_veh_owner, VEH_ROAD))) {
+				m_err = EC_OWNER;
 				return false;
 			}
 		}
@@ -288,22 +295,22 @@
 				m_err = EC_NO_WAY;
 				return false;
 			}
-			/* don't try to enter other company's depots */
-			if (GetTileOwner(m_new_tile) != m_veh_owner) {
+			/* don't try to enter other companies' depots, unless allowed to */
+			if (!(ignore_owner || IsDepotUsageAllowed(m_new_tile, m_veh_owner, VEH_ROAD))) {
 				m_err = EC_OWNER;
 				return false;
 			}
 		}
 		if (IsRailTT() && IsDepotTypeTile(m_new_tile, TT())) {
 			DiagDirection exitdir = GetRailDepotDirection(m_new_tile);
-			if (ReverseDiagDir(exitdir) != m_exitdir) {
+			if (ReverseDiagDir(exitdir) != m_exitdir || !(ignore_owner || IsDepotUsageAllowed(m_new_tile, m_veh_owner, VEH_TRAIN))) {
 				m_err = EC_NO_WAY;
 				return false;
 			}
 		}
 
-		/* rail transport is possible only on tiles with the same owner as vehicle */
-		if (IsRailTT() && GetTileOwner(m_new_tile) != m_veh_owner) {
+		/* rail transport is possible only on tiles where the vehicle is allowed */
+		if (IsRailTT() && !(ignore_owner || IsRailwayTileUsageAllowed(m_new_tile, m_veh_owner))) {
 			/* different owner */
 			m_err = EC_NO_WAY;
 			return false;
